Írjon függvényt, mely megadja a paraméterként kapott, tízes számrendszerben négyjegyű szám első és negyedik jegyének összegét.
Írjon programot, mely négyjegyű számokból álló végjeles sorozatot olvas be a standard bemenetről. A sorozat végjele a 0 szám.
A program írja ki a standard kimenetre, hogy hány olyan négyjegyű szám érkezett, melynek első és negyedik számjegyeinek összege meghaladja az előző számra számolt összeget.

#include <stdio.h>

int szamjegyosszeg(int szam)
{
	int elsojegy = szam % 10;
	int negyedikjegy = (szam % 10000) / 1000;

	return elsojegy + negyedikjegy;
}

int main(void)
{
	int szam;
	int elozoeredm = 0;
	int db = 0;

	scanf("%d", &szam);
	
	while (szam != 0)
	{
		int eredm = szamjegyosszeg(szam);
		if (elozoeredm < eredm) db++;
		elozoeredm = eredm;
		scanf("%d", &szam);
	}

	printf("%d", db);

	return 0;
}

/***************************************************************/
Írjon körlevél-függvényt, amely három sztringet kap paraméterként. Az első sztringet át kell másolnia a harmadikba, de úgy, hogy minden '\#' karakter helyett a második sztringet írja az eredménysztringbe.

Feltételezheti, hogy a harmadik sztring elegendő karakter tárolására alkalmas. Ne használjon szabványos könyvtári függvényeket! Demonstrálja a függvény hívását hiba nélkül lefutó kódrészlettel.

#include <stdio.h>

void strmasol(char* eredeti, char* csere, char* eredm)
{
	int i = 0, j=0;
	while (eredeti[i] != '\0')
	{
		if (eredeti[i] == '#')
		{
			int k = 0;
			while (csere[k] != '\0')
			{
				eredm[j] = csere[k];
				j++;
				k++;
			}
		}
		else
		{
			eredm[j] = eredeti[i];
			j++;
		}

		i++;
	}
	eredm[j] = '\0';
}

int main()
{
	char* s1 = "Oh #, miért vagy te #?";
	char* s2 = "Ferenc";
	char s3[1000];
	
	strmasol(s1, s2, s3);
	printf("%s", s3);

	return 0;
}
/***************************************************************/
Pumped Gabó három táncfigurával készül a Soundra: EXTRA, SZUPER és ELNÖKI.
Minden koreográfiáját e három figura ismételgetésével építi fel.
A koreográfia szakaszos: Minden szakaszban egy adott figurát táncol adott ideig.
Egy négy szakaszból álló koreográfia pl. az alábbi:

(EXTRA, 10 sec), (SZUPER, 5 sec), (EXTRA, 10 sec), (ELNÖKI, 3.8 sec)

a)
Definiáljon felsorolt típust egy figura tárolására!

b)
Definiáljon struktúra típust a koreográfia egy szakaszának tárolására!

Ismert az egyes figurák egységnyi időre vetített energiaigénye, ezt az alábbi táblázat tartalmazza (wattban\footnote{A watt a teljesítmény, vagyis az egységnyi időre eső munkavégzés mértékegysége. 1 W = 1 J/s, ahol J (joule) az energia vagy munka mértékegysége.}):

EXTRA: 20 W
SZUPER:30 W
ELNÖKI:50 W

c)
Írjon függvényt, mely egy szakaszt kap paraméterként, és annak energiaigényét adja vissza joule-ban!

d)
Írjon függvényt, mely a teljes koreográfiát tartalmazó tömböt és egy figurát kap paraméterként, és meghatározza, hogy azt a figurát összesen hány másodpercen keresztül táncolta Gabó, illetve ezzel a figurával hány joule energiát égetett el.

Kódrészletben hozza létre a fenti példakoreográfiát, és hívja meg vele és az EXTRA figurára a d) feladat függvényét!

typedef enum figura{EXTRA, SZUPER, ELNOKI} figura;
/*typedef enum figura{EXTRA = 20, SZUPER = 30, ELNOKI = 50} figura;*/

typedef struct szakasz
{
	figura fig;
	double ido;

} szakasz;

double szakasz_energia(szakasz s)
{
	switch (s.fig)
	{
		case EXTRA: return 20 * s.ido;
		case SZUPER: return 30 * s.ido;
		case ELNOKI: return 50 * s.ido;
	}
/*	return s.fig * s.ido;*/
}

double koreografia_energia_ido(szakasz tomb[], int meret, figura fig, double* ido)
{
	int i;
	double osszido = 0, osszenergia = 0;
	for (i = 0; i < meret; i++)
	{
		if (tomb[i].fig == fig)
		{
			osszido += tomb[i].ido;
			osszenergia+=szakasz_energia(tomb[i]);
		}
	}
	*ido = osszido;
	return osszenergia;
}

int main(void)
{
	szakasz pelda[] = { { EXTRA, 10 }, { SZUPER, 5 }, { EXTRA, 10 }, { ELNOKI, 3.8 } };
	int peldameret = 4;
	double extraido;
	double extraenergia = koreografia_energia_ido(pelda, peldameret, EXTRA, &extraido);

	printf("%lf\t%lf", extraenergia, extraido);

	return 0;
}
